<template>
  <button
      class="button"
      :class="styleClasses"
      :disabled="disabled"
      @click="onClick"
  >
    <slot />
  </button>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from 'vue'

export type Appearance = 'primary' | 'secondary' | 'flat' | 'outline'

export type Size = 's' | 'm' | 'l' | 'xl'

export default defineComponent({
  name: 'TundraButton',
  props: {
    appearance: {
      type: String as PropType<Appearance>,
      default: 'primary',
    },
    size: {
      type: String as PropType<Size>,
      default: 's',
    },
    disabled: {
      type: Boolean as PropType<boolean>,
      default: false,
    },
  },
  setup(props, { emit }) {
    const onClick = () => emit('click');

    const styleClasses = computed(() => {
      const classes: string[] = [props.appearance, props.size];

      return classes;
    });

    return {
      onClick,
      styleClasses,
    }
  }
})
</script>

<style scoped lang="scss">
.button {
  border: 2px solid transparent;
  background: none;
  border-radius: 6px;
  font-family: inherit;
  cursor: pointer;

  // Appearance

  &.primary {
    background: var(--tundra-primary);
    color: var(--tundra-text-secondary);

    &:hover {
      background: var(--tundra-primary-hover);
    }
  }

  &.secondary {
    background: var(--tundra-secondary);
    color: var(--tundra-text-primary);

    &:hover {
      background: var(--tundra-secondary-hover);
    }
  }

  &.flat {
    color: var(--tundra-text-primary);

    &:hover {
      background: var(--tundra-secondary-hover);
    }
  }

  &.outline {
    color: var(--tundra-text-primary);
    border-color: var(--tundra-secondary);

    &:hover {
      border-color: var(--tundra-primary);
    }

    &:disabled {
      border-color: transparent;
    }
  }

  // Size

  &.s {
    padding: 6px 16px;
    font-size: 14px;
  }

  &.m {
    padding: 10px 24px;
    font-size: 17px;
  }

  &.l {
    padding: 14px 32px;
    font-size: 17px;
  }

  &.xl {
    padding: 24px 40px;
    font-size: 20px;
  }

  // State

  &:disabled {
    cursor: default;
    background: var(--tundra-disabled);
    color: var(--tundra-text-disabled);

    &:hover {
      background: var(--tundra-disabled);
    }
  }
}
</style>
